/* AD&D Character & Monster Generator
 * Author: Robert J. Smith, Sr.
 * Date: 10/25/87  */

#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include "local.h"

int chrace, chqual, chclass, chsex;     /* global variables */
int stren, intel, wisdom, cons;         /* containing character statistics */
int dex, chrisma, hp, xlevel;
int chage, xsize;
char *xrace, *xclass, chname[20], *xsex;   /* Text names of variables */

main()
{
  int i, x; long now;
  char end;

  srand(time(&now) % 37);        /* Initialize random number generator */

  cpyright();                    /* Print Opening */
  beginning:
  clrscrn();
  selchar() ;                    /* Select type of character */
  storchar();                    /* Store character text name */
  if ( chrace > 0 && chrace < 9 )
  getlevel();                    /* Get character level */
  getstren();                    /* Get strength characteristic */
  getchris();                    /* Get chrisma characteristic */
  getcon();                      /* Get constitution characteristic */
  getdex();                      /* Get dexterity characteristic */
  getwise();                     /* Get wisdom characteristic */
  getintel();                    /* Get intelligence characteristic */
  chage = 0;
  gethit();                      /* Get hit points */
  chkvital();                    /* Edit vital statistics */
  getvital();                    /* Print vitality stats */
  if ( chrace > 0 && chrace < 9 )
  chklevel();                    /* Check player level */
  clrscrn();
  printf ("\nWould you like to generate another character ?\n");
  printf ("Enter Y for yes or N for no - no will quit program\n");
  cscanf ("%c", &end);
  if ( end == 'y' || end == 'Y' )
   goto beginning;
  else
   beep();
   exit(SUCCEED);                 /* Exit from program */
}

int rnd()      /* Random number generator */
{
 int c;
 c = abs(rand()*.00025);
 if ( c == 0 )
  c = c + 1;
 return(c);
}

selchar()
{
 /* This module is used to select the player character */

 int race, qual, class, size;
 qual = 0;
 class = 0;

 begin:
 clrscrn();
 printf ("\n");
 printf ("Select race of random monsters and/or player charecter:\n");
 printf ("ͻ\n");
 printf ("       Human = 1      Wood Elf = 4         Gnome = 7    \n");
 printf ("    Halfling = 2      Half-Elf = 5      Half-Orc = 8    \n");
 printf ("    Grey Elf = 3         Dwarf = 6                      \n");
 printf ("                                                        \n");
 printf ("        Orc  = 30    Hobgoblin = 34       Gnoll  = 38   \n");
 printf ("     Dragon  = 31   Troglodyte = 35  Jackelwere  = 39   \n");
 printf ("     Kobold  = 32      Bugbear = 36        Orge  = 40   \n");
 printf ("     Goblin  = 33   Lizard Man = 37       Troll  = 41   \n") ;
 printf ("ͼ\n");
 printf ("Enter Choice: ");
 start:
 scanf ("%d", &race);

 if (race < 1 || (race > 8 && race < 30) || race > 41)
   {
   printf ("Character type is unknown - Try again ");
   goto start;
   }
   else
   if (race == 30 || ( race > 31 && race < 42))
    {
     printf ("\n");
     printf ("ͻ\n");
     printf ("     1 = Normal  2 = Superior  3 = King          \n");
     printf ("ͼ\n");
     printf("Enter Quality of Character: ");
     start1:
     scanf("%d", &qual);
     if (qual < 1 || qual > 3 )
      {
      printf ("\nCharacter quality is unknown - Try again ");
      goto start1;
      }
    } else
   if (race == 31 )
    {
     printf ("\n");
     printf ("ͻ\n");
     printf ("     1 = Small   2 = Average   3 = Huge          \n");
     printf ("ͼ\n");
     printf("Enter Size of Dragon: ");
     start3:
     scanf("%d", &size);
     if (size < 1 || size > 3 )
      {
      printf ("\nDragon size is unknown - Try again ");
      goto start3;
      }
    }
    else
    {
 startx:
 printf ("\nPlease Select the Player Character's Class:\n");
 printf ("ͻ\n");
 printf ("  Fighter       =  9        Illustionist   = 15         \n");
 printf ("  Paladin       = 10        Cleric         = 16         \n");
 printf ("  Anti-Paladin  = 11        Druid          = 17         \n");
 printf ("  Ranger        = 12        Anti-Druid     = 18         \n");
 printf ("  Thief         = 13        Assassin       = 19         \n");
 printf ("  Magic User    = 14        Monk           = 20         \n");
 printf ("ͼ\n");
 printf ("Enter Choice: ");
 start2:
 scanf ("%d", &class);
 if (class < 9 || class > 20)
   {
   printf ("\nEnter a number between 9 and 20: ");
   goto start2;
   }
    }
if ( race > 0 && race < 9)
 {
 /* Check to see if character class is legal for the race */
 if ( race == 2 && (class == 10 || class == 11 || class == 12
   || class == 14 || class == 15 || class == 16 || class == 17
   || class == 18 || class == 19 || class == 20))
    goto msg;
 if ((race == 3 || race == 4) && (class == 10 || class == 11 || class == 12
   || class == 15 || class == 16 || class == 17 || class == 18 || class == 20))
    goto msg;
 if ( race == 5 && (class == 10  || class == 15 || class == 20))
   goto msg;
 if (race == 6 && (class == 10 || class == 11 || class == 12
   || class == 15 || class == 16 || class == 17 || class == 18 || class == 20))
    goto msg;
 if (race == 7 && (class == 10 || class == 11 || class == 12
   || class == 14 || class == 16 || class == 17 || class == 18 || class == 20))
    goto msg;
 if (race == 8 && (class == 10 || class == 11 || class == 12
   || class == 14 || class == 17 || class == 18 || class == 20))
    goto msg;
 }
if ( race > 0 && race < 9)
 getsex();
chrace = race;
chqual = qual;
chclass =class;
if (chrace == 31)
   {
   chqual = 0;
   xsize = size;
   }
return;
msg:
printf ("\nThis class is not avail for the character race you selected.");
printf (" Try again - \n");
goto startx;
}

storchar()
/* This module stores the text of the character race and class to
 * a pair of golobal variables for later use. Storchar() calls and
 * uses getclass().*/

{
 char *race;
 int mrace;
 mrace = chrace;

  if (mrace == 1)
   race = "Human ";
  else if (mrace == 2)
   race = "Halfling ";
  else if (mrace == 3)
   race = "Grey Elf ";
  else if (mrace == 4)
   race = "Wood Elf ";
  else if (mrace == 5)
   race = "Half-Elf ";
  else if (mrace == 6)
   race = "Dwarf ";
  else if (mrace == 7)
   race = "Gnome ";
  else if (mrace == 8)
   race = "Half-Orc ";
  else if (mrace == 30)
   race = "Orc ";
  else if (mrace == 31)
   race = "Dragon ";
  else if (mrace == 32)
   race = "Kobolde ";
  else if (mrace == 33)
   race = "Goblin ";
  else if (mrace == 34)
   race = "Hobgoblin ";
  else if (mrace == 35)
   race = "Troglodyte ";
  else if (mrace == 36)
   race = "Bugbear ";
  else if (mrace == 37)
   race = "Lizard Man ";
  else if (mrace == 38)
   race = "Gnoll ";
  else if (mrace == 39)
   race = "Jacklewere ";
  else if (mrace == 40)
   race = "Orge ";
  else if (mrace == 41)
   race = "Troll ";

  getclass();
  xrace = race;
  return;
}

getclass()
/* Getclass() stores the class portion of the charcter race-class pair
 * to a global variable. */

{
 char *class;
 int mclass;
 mclass = chclass;

 if ( chrace > 0 || chrace < 9)
  {
  if (mclass == 9)
   class = "Fighter ";
  else if (mclass == 10)
   class = "Paladin ";
  else if (mclass == 11)
   class = "Anti-Paladin ";
  else if (mclass == 12)
   class = "Ranger ";
  else if (mclass == 13)
   class = "Thief ";
  else if (mclass == 14)
   class = "Magic User ";
  else if (mclass == 15)
   class = "Illustionist ";
  else if (mclass == 16)
   class = "Cleric ";
  else if (mclass == 17)
   class = "Druid ";
  else if (mclass == 18)
   class = "Anti-Druid ";
  else if (mclass == 19)
   class = "Assassin ";
  else if (mclass == 20)
   class = "Monk ";
  }

  if (chqual == 2)
    class = "(Superior)";
  else if (chqual == 3)
    class = "King";
  else if (chqual == 1)
    class = " ";
  else if (chqual == 0)
       {
       if (xsize == 1)
          class = "(Small) ";
       if (xsize == 2)
          class = "(Average) ";
       if (xsize == 3)
          class = "(Huge) ";
       }

  xclass = class;
  return;
  }

getvital()
{
/* Establishes player vitality data */
  char q;

  setpt:
  clrscrn();                /* Clear the screen */
  if (chrace > 0 && chrace < 9 )
  {
  printf ("\nCharacter vitality characteristics:\n\n");
  printf ("Race - %s%s (%s) level: %d\n", xrace, xclass, xsex, xlevel);
  }  else
  {
  printf ("\nMonster vitality characteristics:\n\n");
  printf ("Race - %s%s\n", xrace, xclass);
  }
  printf ("ͻ\n");
  printf (" Strength     = %-2d \n", stren);
  printf (" Intelligence = %-2d \n", intel);
  printf (" Wisdom       = %-2d \n", wisdom);
  printf (" Dexterity    = %-2d \n", dex);
  printf (" Constitution = %-2d \n", cons);
  printf (" Chrisma      = %-2d \n", chrisma);
  printf (" Hit Points   = %-2d \n", hp);
  printf ("ͼ\n");
  printf (" Are you satisfied with the above ?\n");
  printf (" Enter Y for yes or N for no: ");
  cscanf ("%c",&q);
  if ( q == 'n' || q == 'N' ) 
  {
   getstren();
   getchris();
   getcon();
   getdex();
   getwise();
   getintel();
   gethit();
   chkvital();
   goto setpt;
   } else
   return;
}

getstren()
{
/* Computes strength */

int a, b, c;
a = rnd();
if (a > 6 )
 a = 6;
b = rnd();
if (b > 6 )
 b = 6;
c = rnd();
if (c > 6 )
 c = 6;
stren = a + b + c;
return;

}

getintel()
{
int a, b, c;
a = rnd();
if (a > 6 )
 a = 6;
b = rnd();
if (b > 6 )
 b = 6;
c = rnd();
if (c > 6 )
 c = 6;
 intel = a + b + c;
 return;
}

getwise()
{
int a, b, c;
a = rnd();
if (a > 6 )
 a = 6;
b = rnd();
if (b > 6 )
 b = 6;
c = rnd();
if (c > 6 )
 c = 6;
 wisdom = a + b + c;
 return;
}

getdex()
{
int a, b, c;
a = rnd();
if (a > 6 )
 a = 6;
b = rnd();
if (b > 6 )
 b = 6;
c = rnd();
if (c > 6 )
 c = 6;
 dex = a + b + c;
 return;
}

getcon()
{
int a, b, c;
a = rnd();
if (a > 6 )
 a = 6;
b = rnd();
if (b > 6 )
 b = 6;
c = rnd();
if (c > 6 )
 c = 6;
 cons = a + b + c;
 return;
}
getchris()
{
int a, b, c;
a = rnd();
if (a > 6 )
 a = 6;
b = rnd();
if (b > 6 )
 b = 6;
c = rnd();
if (c > 6 )
 c = 6;
 chrisma = a + b + c;
 return;
}

getsex()
/* gets character's sex (male or female) and stores to global variables */
   {

     int sex;

     printf ("\n");
     printf ("ͻ\n");
     printf ("     1 = Male    2 = Female    \n");
     printf ("ͼ\n");
     printf("Enter Sex of Character: ");
     start1:
     scanf("%d", &sex);
     if (sex < 1 || sex > 2 )
      {
      printf ("\nYou must be kidding me - Try again ");
      goto start1;
      }
      chsex = sex;
      if ( sex == 1 )
       xsex = "Male ";
      else
       xsex = "Female ";

      return;
}

getlevel()
 {
 /* Obtains  character level */

 int mlevel;

 printf ("Enter Character level: ");
 start:
 scanf ("%d", &mlevel);
 if ( mlevel < 1 || mlevel > 11 )
  {
  printf ("Enter a number between 1 and 11 : ");
  goto start;
  }
  if ( chrace == 2 && mlevel > 6 )
     {
     printf (" Halfling Fighters are limited to level 6 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if (( chrace == 3 || chrace == 4) && chclass == 9 && mlevel > 7)
     {
     printf ("Elven Fighters are limited to level 7 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if (( chrace == 3 || chrace == 4) && chclass == 14 && mlevel > 11)
     {
     printf ("Elven Magic Users are limited to level 11 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if (( chrace == 3 || chrace == 4) && chclass == 19 && mlevel > 10)
     {
     printf ("Elven Assassins are limited to level 10 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if ( chrace == 5 && chclass == 19 && mlevel > 11)
     {
     printf ("Half-Elf Assassins are limited to level 11 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if ( chrace == 5 && chclass == 16 && mlevel > 5)
     {
     printf ("Half-Elf Clerics are limited to level 5 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if ( chrace == 5 && chclass == 9 && mlevel > 8)
     {
     printf ("Half-Elf Fighters are limited to level 8 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if ( chrace == 5 && chclass == 12 && mlevel > 8)
     {
     printf ("Half-Elf Rangers are limited to level 8 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if ( chrace == 5 && chclass == 14 && mlevel > 8)
     {
     printf ("Half-Elf Magic Users are limited to level 8 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if ( chrace == 5 && chclass == 19 && mlevel > 11)
     {
     printf ("Half-Elf Assassins are limited to level 11 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if ( chrace == 6 && chclass == 9 && mlevel > 9)
     {
     printf ("Dwraf Fighters are limited to level 9 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if ( chrace == 6 && chclass == 19 && mlevel > 9)
     {
     printf ("Dwraf Assassins are limited to level 9 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if ( chrace == 7 && chclass == 9 && mlevel > 6)
     {
     printf ("Gnome Fighters are limited to level 6 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if ( chrace == 7 && chclass == 15 && mlevel > 7)
     {
     printf ("Gnome Illustionists are limited to level 7 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if ( chrace == 7 && chclass == 19 && mlevel > 8)
     {
     printf ("Gnome Assassins are limited to level 8 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if ( chrace == 8 && chclass == 16 && mlevel > 4)
     {
     printf ("Half-Orc Clerics are limited to level 4 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if ( chrace == 8 && chclass == 9 && mlevel > 10)
     {
     printf ("Half-Orc Fighters are limited to level 10 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  if ( chrace == 8 && chclass == 13 && mlevel > 8)
     {
     printf ("Half-Orc Thieves are limited to level 8 and below\n");
     printf ("Please reenter level - ");
     goto start;
     }
  xlevel = mlevel;
  return;
 }

chklevel()
 {
 /* Check level against characteristics for legality */

 int mstren, mintel, mdex;
 int c, zlevel;
 mstren = stren;
 mdex = dex;
 mintel = intel;
 zlevel = xlevel;

 printf ("\n");
 if (chrace == 2 && chclass == 9 && mstren < 17 && xlevel > 4)
    {
    printf ("Halfling Fighters with strength of less than 17 are limited\n");
    printf ("to level 4. Reducing level to 4.\n");
    xlevel = 4;
    }
 if ((chrace == 3 || chrace == 4) && chclass == 9 && mstren < 17 && xlevel > 5)
    {
    printf ("Elven Fighters with strength of less than 17 are limited\n");
    printf ("to level 5. Reducing level to 5.\n");
    xlevel = 5;
    }
 if ((chrace == 3 || chrace == 4) && chclass == 9 && mstren == 17 && xlevel > 6)
    {
    printf ("Elven Fighters with strength of 17 are limited\n");
    printf ("to level 6. Reducing level to 6.\n");
    xlevel = 6;
    }
 if ((chrace == 3 || chrace == 4) && chclass == 14 && mintel < 17 && xlevel > 9)
    {
    printf ("Elven Magic Users with intelligence of less than 17 are limited\n");
    printf ("to level 9. Reducing level to 9.\n");
    xlevel = 9;
    }
 if ((chrace == 3 || chrace == 4) && chclass == 14 && mintel == 17 && xlevel > 10)
    {
    printf ("Elven Magic Users with intelligence of 17 are limited\n");
    printf ("to level 10. Reducing level to 10.\n");
    xlevel = 10;
    }
 if (chrace == 5 && (chclass == 9 || chclass == 12)
  && mstren < 17 && xlevel > 6)
    {
    printf ("Half-Elf Fighters and Rangers with strength of ");
    printf ("less than 17 are limited\n");
    printf ("to level 6. Reducing level to 6.\n");
    xlevel = 6;
    }
 if (chrace == 5 && (chclass == 9 || chclass == 12)
  && mstren == 17 && xlevel > 7)
    {
    printf ("Half-Elf Fighters and Rangers with strength of 17 are limited\n");
    printf ("to level 7. Reducing level to 7.\n");
    xlevel = 7;
    }
 if (chrace == 5 && chclass == 14 && mintel < 17 && xlevel > 6)
    {
    printf ("Half-Elf Magic Users with intelligence of less than 17 are limited\n");
    printf ("to level 6. Reducing level to 6.\n");
    xlevel = 6;
    }
 if (chrace == 5 && chclass == 14 && mintel == 17 && xlevel > 7)
    {
    printf ("Half-Elf Magic Users with intelligence of less than 17 are limited\n");
    printf ("to level 7. Reducing level to 7.\n");
    xlevel = 7;
    }
 if (chrace == 6 && chclass == 9 && mstren < 17 && xlevel > 7)
    {
    printf ("Dwarf Fighters with strength of less than 17 are limited\n");
    printf ("to level 7. Reducing level to 7.\n");
    xlevel = 7;
    }
 if (chrace == 6 && chclass == 9 && mstren == 17 && xlevel > 8)
    {
    printf ("Dwarf Fighters with strength equal to 17 are limited\n");
    printf ("to level 8. Reducing level to 8.\n");
    xlevel = 8;
    }
 if (chrace == 7 && chclass == 9 && mstren == 18 && xlevel > 5)
    {
    printf ("Gnome Fighters with strength equal to 18 are limited\n");
    printf ("to level 5. Reducing level to 5.\n");
    xlevel = 5;
    }
 if (chrace == 7 && chclass == 15 && mdex < 17 && xlevel > 5)
    {
    printf ("Gnome Illustionists with dexterity less than 17 are limited\n");
    printf ("to level 5. Reducing level to 5.\n");
    xlevel = 5;
    }
 if (chrace == 7 && chclass == 15 && mdex == 17 && mintel == 17 && xlevel > 6)
    {
    printf ("Gnome Illustionists with dexterity equal to 17\n");
    printf ("and intelligence equal to 17 are limited\n");
    printf ("to level 6. Reducing level to 6.\n");
    xlevel = 6;
    }
 if (chrace == 8 && chclass == 13 && mdex < 17 && xlevel > 6)
    {
    printf ("Gnome Illustionists with dexterity less than 17");
    printf (" are limited\n");
    printf ("to level 6. Reducing level to 6.\n");
    xlevel = 6;
    }
 if (chrace == 8 && chclass == 13 && mdex == 17 && xlevel > 7)
    {
    printf ("Gnome Illustionists with dexterity equal to 17");
    printf (" are limited\n");
    printf ("to level 7. Reducing level to 7.\n");
    xlevel = 7;
    }
    if ( zlevel != xlevel )
     wait();
 }

chkvital()
 {
 /* This module will apply AD & D rules to the vital statistics already
  * computed; adjusting these as necessary */

 int mstren, mintel, mwise, mcons;
 int mdex, mchrisma, mhp;
 mstren = stren;
 mintel = intel;
 mwise = wisdom;
 mcons = cons;
 mdex = dex;
 mchrisma = chrisma;

 if ( (chrace == 2 || chrace == 6 || chrace == 8) && mcons == 18 )
    mcons = 19;                   /* Max constitution for halflings, dwarfs, */
                                 /* and Half-Orcs is 19 not 18 */

 if ( (chrace == 3 || chrace == 4) && mdex == 18 )
    mdex = 19;                   /* Elves can have a max dexterity of 19 */

 if ( chrace == 40 )             /* Ogres are very strong */
   mstren =  19;
 if ( chrace == 41 )             /* Trolls have high constitutions */
   mcons = 20;

 if ( chrace > 29 && chrace < 42 )     /* Lower intelligence for monsters */
   mintel = (mintel/2);

 if ( chrace == 2 )             /* Set minimum for Halfling */
    {
    if ( mstren < 6 )
       mstren = 6;
    if ( mintel < 6 )
       mintel = 6;
    if ( mwise < 3 )
       mwise = 3;
    if ( mdex < 8 )
       mdex = 8;
    if ( mcons < 10 )
       mcons = 10;
    if ( mchrisma < 3 )
       mchrisma = 3;
    }

 if ( chrace == 3 || chrace == 4 )  /* Set minimum for Elves */
    {
    if ( mstren < 3 )
       mstren = 3;
    if ( mintel < 8 )
       mintel = 8;
    if ( mwise < 3 )
       mwise = 3;
    if ( mdex < 7 )
       mdex = 7;
    if ( mcons < 6 )
       mcons = 6;
    if ( mchrisma < 8 )
       mchrisma = 8;
    }

 if ( chrace == 5 )             /* Set minimum for Half-Elf */
    {
    if ( mstren < 3 )
       mstren = 3;
    if ( mintel < 4 )
       mintel = 4;
    if ( mwise < 3 )
       mwise = 3;
    if ( mdex < 6 )
       mdex = 6;
    if ( mcons < 6 )
       mcons = 6;
    if ( mchrisma < 3 )
       mchrisma = 3;
    }

 if ( chrace == 6 )         /* Set minimum for Dwarfs */
    {
    if ( mstren < 8 )
       mstren = 8;
    if ( mintel < 3 )
       mintel = 3;
    if ( mwise < 3 )
       mwise = 3;
    if ( mdex < 3 )
       mdex = 3;
    if ( mcons < 12 )
       mcons = 12;
    if ( mchrisma < 3 )
       mchrisma = 3;
    }

 if ( chrace == 7 )             /* Set minimum for Gnomes */
    {
    if ( mstren < 6 )
       mstren = 6;
    if ( mintel < 7 )
       mintel = 7;
    if ( mwise < 3 )
       mwise = 3;
    if ( mdex < 3 )
       mdex = 3;
    if ( mcons < 8 )
       mcons = 8;
    if ( mchrisma < 3 )
       mchrisma = 3;
    }

 if ( chrace == 8 )             /* Set minimum for Half-Orc */
    {
    if ( mstren < 6 )
       mstren = 6;
    if ( mintel < 3 )
       mintel = 3;
    if ( mwise < 3 )
       mwise = 3;
    if ( mdex < 3 )
       mdex = 3;
    if ( mcons < 13 )
       mcons = 13;
    if ( mchrisma < 3 )
       mchrisma = 3;
    }

 if ( chrace == 2 && chsex == 1 )          /* Set maximum for Halfling */
    {
    if ( mstren > 17 )
       mstren = 17;
    if ( mwise > 17 )
       mwise = 17;
    } else if ( chrace == 2 && chsex == 2 )
      {
      if ( mstren > 14 )
        mstren = 14;
      if ( mwise > 17 )
        mwise = 17;
      }

 if ( (chrace == 3 || chrace == 4) && chsex == 2 )  /* Set maximum for Elves */
      {
      if ( mstren > 16 )
        mstren = 16;
      }

 if ( chrace == 5 && chsex == 2 )        /* Set maximum for Half-Elf */
    {
    if ( mstren > 17 )
       mstren = 17;
    }

 if ( chrace == 6 && chsex == 1 )       /* Set maximum for Dwarfs */
    {
    if ( mdex > 17 )
       mdex = 17;
    if ( mchrisma > 16 )
       mchrisma = 16;
    } else if ( chrace == 6 && chsex == 2 )
      {
      if ( mstren > 17 )
         mstren = 17;
      if ( mdex > 17 )
         mdex = 17;
      if ( mchrisma > 16 )
         mchrisma = 16;
      }

 if ( chrace == 7 && chsex == 1 )       /* Set maximum for Gnomes */
    {
    if ( mdex > 17 )
       mdex = 17;
    if ( mchrisma > 16 )
       mchrisma = 16;
    } else if ( chrace == 7 && chsex ==2 )
      {
      if ( mstren > 17 )
         mstren = 17;
      if ( mdex > 17 )
         mdex = 17;
      if ( mchrisma > 16 )
         mchrisma = 16;
      }

 if ( chrace == 8 )            /* Set maximum for Half-Orc */
    {
    if ( mintel > 17 )
       mintel = 17;
    if ( mwise > 14 )
       mwise = 14;
    if ( mdex > 17 )
       mdex = 17;
    if ( mchrisma > 12 )
       mchrisma = 12;
    }

 /* If character is a female lower strength by 1 and raise dexterity 1 */

 if (( chrace > 0 && chrace < 9) && chsex == 2 )
    {
    mstren = (mstren - 1);
    if ( mdex < 19)
     mdex = mdex + 1;
    }

 stren = mstren;
 intel = mintel;
 wisdom = mwise;
 cons = mcons;
 dex = mdex;
 chrisma = mchrisma;
 return;
 }

getage()
 {
 int age;

 printf ("       Select age of Dragon:\n");
 printf ("ͻ\n");
 printf ("  1   Very young --  1-5 years      \n");
 printf ("  2   Young -- 6-15 years           \n");
 printf ("  3   Sub-Adult -- 16-25 years      \n");
 printf ("  4   Young Adult -- 26-50 years    \n");
 printf ("  5   Adult -- 51-100 years         \n");
 printf ("  6   Old -- 101-200 years          \n");
 printf ("  7   Very Old -- 201-400 years     \n");
 printf ("  8   Ancient -- 401 + years        \n");
 printf ("ͼ\n");
 printf ("Enter Choice: ");
 scanf ("%d", &age);
 chage = age;
 return;
 }

gethit()
{
  int i, a;
  int mhp = 0;                            /* Set Hit Points to zero */
  if ( chrace > 0 && chrace < 9)
  {
  for ( i = 1; i < (xlevel + 1); i++)     /* Compute Hit Points  based */
   mhp  = mhp + rnd();                    /* on player level */
  } else mhp = rnd();

/* Modify hit points according to character class, level, and constitution */

 if ( chrace > 0 && chrace < 9 )    /* For Characters */
  {
  if ( chclass == 16 )             /* Cleric */
    {
    if ( chclass == 16 && xlevel > 9 && mhp > (72+((xlevel-9)*2)))
       mhp = ( 72 + ((xlevel - 9) * 2));
    } else
    if (chclass == 9 || chclass == 10 || chclass == 11 )     /* Fighters */
    {
    if ( xlevel > 9 && mhp > (90+((xlevel-9)*3)))
       mhp = ( 90 + ((xlevel - 9) * 3));
    } else
    if (chclass == 12)                 /* Ranger */
    {
    if ( mhp < ((xlevel - 1) + 2))
       mhp = xlevel -1 + 2;
    if ( mhp > (((xlevel -1) + 2) * 8))
       mhp = (((xlevel -1) + 2) * 8);
    if ( xlevel > 10 && mhp > (((xlevel -10) * 2) + 88) )
       mhp = (((xlevel -10)*2)+88);
    } else
    if (chclass == 13)         /* Thieves */
    {
    if ( xlevel > 10 && mhp > (60 + ((xlevel-10)*2)))
       mhp = ( 60 + ((xlevel - 10) * 2));
    } else
    if (chclass == 14 || chclass == 15 || chclass == 20)
    {
    if ( mhp > (xlevel * 4))
       mhp = xlevel * 4;
    } else
    if (chclass == 19)
    {
    mhp = xlevel * 6;
    }
   if (cons == 3 && mhp > 2)
      mhp = mhp - 2;
   if (cons == 3 && mhp == 1)
      mhp = 1;
   if (cons > 3 && cons < 7 && mhp > 1)
      mhp = mhp - 1;
   if (cons == 15 )
      mhp = mhp + 1;
   if (cons > 15)
      mhp = mhp + 2;
   if (cons == 17 && (chclass == 9 || chclass == 10 || chclass == 11))
      mhp = mhp + 1;
   if (cons == 18 && (chclass == 9 || chclass == 10 || chclass == 11))
      mhp = mhp + 2;
  } else if ( chrace > 29 && chrace < 42 )   /* For Monsters */
    {
    if ( chrace == 30 && chqual == 2 && mhp < 8)
       mhp = 8;
    if ( chrace == 30 && chqual == 3 && mhp < 11)
       mhp = 11;
    else if ( chrace == 31 )
       {
       mhp = 0;
       if ( chage == 0 )
         getage();
       if (chage == 1 )
            mhp  = rnd();
         if (mhp > 8)
            mhp = 8;
       if (chage == 2 )
         {
         for ( i = 1; i < 3; i++)
            mhp  = mhp + rnd();
         if (mhp > (2 * 8))
            mhp = 16;
         }
       if (chage == 3 )
         {
         for ( i = 1; i < 4; i++)
            mhp  = mhp + rnd();
         if (mhp > (3 * 8))
            mhp = 3 * 8;
         }
       if (chage == 4 )
         {
         for ( i = 1; i < 5; i++)
            mhp  = mhp + rnd();
         if (mhp > (4 * 8))
            mhp = 4 * 8;
         }
       if (chage == 5 )
         {
         for ( i = 1; i < 6; i++)
            mhp  = mhp + rnd();
         if (mhp > (5 * 8))
            mhp = 5 * 8;
         }
       if (chage == 6 )
         {
         for ( i = 1; i < 7; i++)
            mhp  = mhp + rnd();
         if (mhp > (6 * 8))
            mhp = 6 * 8;
         }
       if (chage == 7 )
         {
         for ( i = 1; i < 8; i++)
            mhp  = mhp + rnd();
         if (mhp > (7 * 8))
            mhp = 7 * 8;
         }
       if (chage == 8 )
         {
         for ( i = 1; i < 9; i++)
            mhp  = mhp + rnd();
         if (mhp > (8 * 8))
            mhp = 8 * 8;
         }
       } else
    if (chrace == 32 )
      {
      mhp = 0;
      if (chqual == 1)
         {
         mhp = rnd();
         if ( mhp > 8)
            mhp = 8;
        }
      if (chqual == 2)
         {
         for ( i = 1; i < 4; i++)
           mhp = mhp + rnd();
         if ( mhp > 16)
            mhp = 16;
        }
      if (chqual == 3)
         {
         for ( i = 1; i < 5; i++)
           mhp = mhp + rnd();
         if ( mhp > 32)
            mhp = 32;
        }
      } else
      if (chrace == 33)
       {
       if ( mhp > 7)
          mhp = 7;
       } else
      if (chrace == 34)
        mhp = mhp + 1;
      else
      if (chrace == 35)
       {
       mhp = 0;
       for ( i = 1; i < 3; i++)
         mhp = mhp + rnd();
       if (mhp > 16 )
         mhp = 16;
       } else
      if (chrace == 36)
       {
       mhp = 0;
       for ( i = 1; i < 4; i++)
         mhp = mhp + rnd();
       if (mhp > 24)
         mhp = 24;
       mhp = mhp + 1;
       } else
      if (chrace == 37)
       {
       mhp = 0;
       for ( i = 1; i < 3; i++)
         mhp = mhp + rnd();
       if (mhp > 18)
         mhp = 18;
       mhp = mhp + 1;
       } else
      if (chrace == 38)
       {
       mhp = 0;
       for ( i = 1; i < 3; i++)
         mhp = mhp + rnd();
       if (mhp > 18)
         mhp = 18;
       } else
      if (chrace == 39)
       {
       mhp = 0;
       for ( i = 1; i < 5; i++)
         mhp = mhp + rnd();
       if (mhp > 32)
         mhp = 32;
       } else
      if (chrace == 40)
       {
       mhp = 0;
       for ( i = 1; i < 5; i++)
         mhp = mhp + rnd();
       if (mhp > 32)
         mhp = 32;
       mhp = mhp + 1;
       } else
      if (chrace == 41)
       {
       mhp = 0;
       for ( i = 1; i < 7; i++)
         mhp = mhp + rnd();
       if (mhp > 48)
         mhp = 48;
       mhp = mhp + 6;
       }
    }

  hp = mhp;
  return;
}

cpyright()
 {
 clrscrn();
 printf ("\n");
 printf ("\n");
 printf ("      ͻ\n");
 printf ("             Random Character and Monster Generator           \n");
 printf ("                                                              \n");
 printf ("                 Author: Robert J.Smith, Sr.                  \n");
 printf ("                                                              \n");
 printf ("              Techincal Advisor: Robert J. Smith, Jr.         \n");
 printf ("                                                              \n");
 printf ("        This program was written primarily for my son.        \n");
 printf ("        It generates basic characteristics for role playing   \n");
 printf ("        characters and monsters. The rules of Advanced        \n");
 printf ("        Dungeons & Dragons (Trademark of TSR) have been       \n");
 printf ("        followed as closely as possible. I hope others may    \n");
 printf ("        find it usefull.                                      \n");
 printf ("                                                              \n");
 printf ("        Chargen simulates rolling the dice to obtain the      \n");
 printf ("        values for each character/monster characteristic.     \n");
 printf ("                                                              \n");
 printf ("        This program is released into the public domain       \n");
 printf ("        and may be freely copied and distributed.             \n");
 printf ("                                                              \n");
 printf ("        Pausing for 3 seconds - Please wait .......           \n");
 printf ("      ͼ\n");
 wait();
 beep();
 }


